module TalltyImportExport
  class ExportForm < TalltyImportExport::Export
    def initialize
      super({})
    end

    class << self
      def form_transfer_to_headers form

      end
    end

    def export_workbook workbook, association_records, **options
      # excel导出样式
      alignment = { vertical: :center, horizontal: :center }
      border    = { color: '969696', style: :thin }
      title1 = workbook.styles.add_style(alignment: alignment, border: border, sz: 12, b: true)
      title2 = workbook.styles.add_style(alignment: alignment, border: border, bg_color: "2a5caa",  sz: 12, fg_color: "fffffb")
      title3 = workbook.styles.add_style(alignment: alignment.merge(wrap_text: true), border: border, sz: 10)
      _sheet_name = respond_to?(:sheet_name) ? self.sheet_name : nil

      headers = export_headers_result **options


      workbook.add_worksheet(name: _sheet_name) do |sheet|
        if respond_to?(:first_header)
          row_index = Axlsx.col_ref(headers.flatten_value.size - 1)
          sheet.merge_cells("A1:#{row_index}1")
          sheet.add_row [first_header], style: title1, height: 30
        end

        index = 0

        sheet.add_row headers.flatten_value.map{ |header| header.name }, style: title2, height: 25
        index += 1

        value_seq_to_axios = {}
        formats = []
        association_records.each do |association_record|
          records = @each_method.present? ?
            (try_method(association_record, @each_method) || [nil]) :
            [association_record]

          records.each do |record|
            lines = TalltyImportExport::ExportPayload.new(record, headers: headers) do |payload, header|
              _data = header[:source] ?
                handle_data(association_record, header, index) :
                handle_data(payload, header, index)
            end.lines

            result = []

            lines.transpose.map do |transposed_line|
              line = transposed_line
              while line[0].nil?
                line.shift
                line.push(false)
              end
              line
            end.transpose.each do |line|
              # if line.select(&:itself).count > 0
                result << line
              # end
            end

            # p '----------------------------------------------------------------'
            # result.uniq.each { |x| p x }
            result_uniq = result.uniq do |line|
              line.map(&:value)
            end

            result_uniq.each_with_index do |line, row_index|
              row = []
              line.each_with_index do |value, col_index|
                row << value.value
                unless value_seq_to_axios[value.seq]
                  value_seq_to_axios[value.seq] = []
                end
                value_seq_to_axios[value.seq] << [col_index , row_index + index]
                formats.push(headers.flatten_value[col_index].format&.to_sym || (row.is_a?(String) ? :string : nil))
              end
              sheet.add_row(row, style: title3, height: @row_height, types: formats)
              index += 1
              formats = []
            end
          end
        end

        value_seq_to_axios.values.each do |axios_ary|
          if axios_ary.count > 1
            top_right = [axios_ary.map(&:first).min, axios_ary.map(&:last).min]
            bottom_left = [axios_ary.map(&:first).max, axios_ary.map(&:last).max]
            sheet.merge_cells(
              Axlsx::cell_r(top_right.first, top_right.last) + ':' + Axlsx::cell_r(bottom_left.first, bottom_left.last)
            )
          end
        end
      end
    end


    def export_headers_result **options
      @headers = options.symbolize_keys[:headers]
      super(**options)
      @headers = TalltyImportExport::Attr::ExportHeader.new({ items: @headers })
    end

  end
end
